#ifdef GL_ES
precision mediump float;
#endif

uniform float time;
uniform vec2 mouse;
uniform vec2 resolution;

uniform float lowFreq;
uniform float value0;
uniform float value1;
uniform float value2;
uniform float value3;

void main( void ) {
	vec3 light_color = vec3(1.2,0.8,0.6);
	
	float t = time*20.0;
	vec2 position = ( gl_FragCoord.xy -  resolution.xy*.5 ) / resolution.x;
	float a = sin(value2 * 2.0 * 3.14) * t / 10.0 + 10.0 * sin(value1 * 2.0 * 3.14) * length(position);
	mat2 m2x2 = mat2(
	   cos(a), -sin(a), 
	   sin(a), cos(a)
	);
	position = m2x2 * position;

	// 256 angle steps
	float angle = atan(position.y,position.x)/(2.*3.14159265359);
	angle -= floor(angle);
	float rad = length(position);
	
	float color = 0.0;
	for (int i = 0; i < (1.0 + value0 * 16.0); i++) {
		float angleFract = fract(angle*256.);
		float angleRnd = floor(angle*256.)+1.;
		float angleRnd1 = fract(angleRnd*fract(angleRnd*.7235)*45.1);
		float angleRnd2 = fract(angleRnd*fract(angleRnd*.82657)*13.724);
		float t = t+angleRnd1*10.;
		float radDist = sqrt(angleRnd2+float(i));
		
		float adist = radDist/rad*.1;
		float dist = (t*.1+adist);
		dist = abs(fract(dist)-.5);
		color +=  (1.0 + 24.0 * lowFreq * lowFreq) * (1.0 / (dist))*cos(0.7*(sin(t)))*adist/radDist/30.0;

		angle = fract(angle+.61);
	}
	
	
	gl_FragColor = vec4(color,color,color,1.0)*vec4(light_color,1.0);
}